/// <reference path="babylon.d.ts" />
/// <reference path="babylon.js" />

var BjsApp = BjsApp || {};

var score = 0;

BjsApp.init = function () {

    var userBullets = [];
    var aliens1 = [];
    var aliens2 = [];
    var aliens3 = [];
    var aliens4 = [];
    var aliens5 = [];
    var shotLimit = 5;
    var direction = 1;
    var scaling = 1;
    var throttle = 1;
    var lives = 3;
    var maxWidth = 1024;
    var halfWidth = 512;
    var leftCol = 1;
    var rigthCol = 5;
    var player1;
  

    // window.addEventListener('DOMContentLoaded', function () {
    // get the canvas DOM element
    var canvas = document.getElementById('renderCanvas');

    maxWidth = canvas.scrollWidth;
    halfWidth = maxWidth / 2;

    // load the 3D engine
    var engine = new BABYLON.Engine(canvas, true);


    // createScene function that creates and return the scene
    var createScene = function () {
        // create a basic BJS Scene object
        var scene = new BABYLON.Scene(engine);

        scene.fogEnabled = false;

        //scene.debugLayer.show();
        // scene.debugLayer.show({
            // initialTab: 2,
            // parentElement: document.getElementById('#mydiv'),
            // newColors: {
                // backgroundColor: '#eee',
                // backgroundColorLighter: '#fff',
                // backgroundColorLighter2: '#fff',
                // backgroundColorLighter3: '#fff',
                // color: '#333',
                // colorTop: 'red',
                // colorBottom: 'blue'
            // }
        // });

        // create a FreeCamera, and set its position to (x:0, y:5, z:-10)
        var camera = new BABYLON.FreeCamera('camera1', new BABYLON.Vector3(0, 2.5, -5), scene);


        // target the camera to scene origin
        camera.setTarget(BABYLON.Vector3.Zero());

        // attach the camera to the canvas
        camera.attachControl(canvas, false);

        // create a basic light, aiming 0,1,0 - meaning, to the sky
        var light = new BABYLON.HemisphericLight('light1', new BABYLON.Vector3(0, 1, 0), scene);

        //Display Score

        var JoystickAxis = function () {
            JoystickAxis[JoystickAxis["X"] = 0] = "X";
            JoystickAxis[JoystickAxis["Y"] = 1] = "Y";
            JoystickAxis[JoystickAxis["Z"] = 2] = "Z";
        };

        var vjLeft = new BABYLON.VirtualJoystick(true);
        var vjRight = new BABYLON.VirtualJoystick(false);

        //vjLeft.setJoystickSensibility(0.6);

        //                vjLeft._leftJoystick = true;
        //                vjRight._leftJoystick = false;
        //vjLeft._onPointerDown = function (e) { }

        // Skybox
        var skybox = BABYLON.Mesh.CreateBox("skyBox", 20.0, scene);
        var skyboxMaterial = new BABYLON.StandardMaterial("skyBox", scene);
        //don't render what we can't see
        skyboxMaterial.backFaceCulling = false;
        skyboxMaterial.reflectionTexture = new BABYLON.CubeTexture("./skybox", scene);
        skyboxMaterial.reflectionTexture.coordinatesMode = BABYLON.Texture.SKYBOX_MODE;
        skyboxMaterial.diffuseColor = new BABYLON.Color3(0, 0, 0);
        skyboxMaterial.specularColor = new BABYLON.Color3(0, 0, 0);
        skyboxMaterial.disableLighting = true;
        skybox.material = skyboxMaterial;


        vjLeft._onPointerMove = function (leftMove) {

            ///
            // Intercept Pos.x and then differentiate between Left and Right
            ///
            //console.log("leftMove.clientX " + leftMove.clientX + " half " + halfWidth);

            if (leftMove.clientX < halfWidth) {

                // If the current pointer is the one associated to the joystick (first touch contact)
                if (this._joystickPointerID == leftMove.pointerId) {
                    this._joystickPointerPos.x = leftMove.clientX;
                    this._joystickPointerPos.y = leftMove.clientY;
                    this._deltaJoystickVector = this._joystickPointerPos.clone();
                    this._deltaJoystickVector = this._deltaJoystickVector.subtract(this._joystickPointerStartPos);
                    var directionLeftRight = this.reverseLeftRight ? -1 : 1;
                    var deltaJoystickX = directionLeftRight * this._deltaJoystickVector.x / this._inversedSensibility;
                    switch (this._axisTargetedByLeftAndRight) {
                        case JoystickAxis.X:
                            this.deltaPosition.x = Math.min(1, Math.max(-1, deltaJoystickX));
                            break;
                        case JoystickAxis.Y:
                            this.deltaPosition.y = Math.min(1, Math.max(-1, deltaJoystickX));
                            break;
                        case JoystickAxis.Z:
                            this.deltaPosition.z = Math.min(1, Math.max(-1, deltaJoystickX));
                            break;
                    }
                    var directionUpDown = this.reverseUpDown ? 1 : -1;
                    var deltaJoystickY = directionUpDown * this._deltaJoystickVector.y / this._inversedSensibility;
                    switch (this._axisTargetedByUpAndDown) {
                        case JoystickAxis.X:
                            this.deltaPosition.x = Math.min(1, Math.max(-1, deltaJoystickY));
                            break;
                        case JoystickAxis.Y:
                            this.deltaPosition.y = Math.min(1, Math.max(-1, deltaJoystickY));
                            break;
                        case JoystickAxis.Z:
                            this.deltaPosition.z = Math.min(1, Math.max(-1, deltaJoystickY));
                            break;
                    }
                    console.log(this._deltaJoystickVector);
                    player4.position.x += this._deltaJoystickVector.x / 1000; // / 10;  //was 1000

                    if (player4.position.x > 3)
                        player4.position.x = 3;

                    if (player4.position.x < -3)
                        player4.position.x = -3;

                    player4.position.y -= this._deltaJoystickVector.y / 1000; // / 10;  //was 1000

                    if (player4.position.y > 2)
                        player4.position.y = 2;

                    if (player4.position.y < -2)
                        player4.position.y = -2;
                }
            }
        };


        vjRight._onPointerDown = function (e) {

            //console.log("e.clientX " + e.clientX + " half " + halfWidth);
            //console.log("e.clientY " + e.clientY);

            if (e.clientX > halfWidth) {

                //console.log("vjRight fire");

                if (userBullets.length < shotLimit) {
                    var userBulletClone = userBullet.clone(userBullet.name);
                    userBulletClone.id = userBullets.length + 1;
                    userBulletClone.isVisible = true;
                    userBulletClone.checkCollisions = true;
                    userBulletClone.ellipsoid = new BABYLON.Vector3(0.5, .5, 0.5);
                    userBulletClone.position.x = player4.position.x;
                    userBulletClone.position.y = player4.position.y;
                    userBulletClone.position.z = player4.position.z;
                    userBullets.push(userBulletClone);
                }
            }

        }

        // create a built-in "sphere" shape; its constructor takes 5 params: name, width, depth, subdivisions, scene
        //      var sphere = BABYLON.Mesh.CreateCylinder("sphere", 0.2, 1, 1, 16, 1, scene);

        var redMat = new BABYLON.StandardMaterial("ground", scene);
        redMat.diffuseColor = new BABYLON.Color3(1.0, 0.2, 0.7);
        redMat.specularColor = new BABYLON.Color3(1.0, 0.2, 0.7);
        redMat.emissiveColor = BABYLON.Color3.Red();


        var assetsManager = new BABYLON.AssetsManager(scene);
        var player4 = assetsManager.addMeshTask("player4", "", "assets/images/", "player.babylon");
        player4.onSuccess = function (task) {
            task.loadedMeshes[0].position = new BABYLON.Vector3(1, 1, 1);
            task.loadedMeshes[0].scaling = new BABYLON.Vector3(0.08, 0.08, 0.08);

            //task.loadedMeshes[1].position = new BABYLON.Vector3(1, 1, 1);
            //task.loadedMeshes[1].scaling = new BABYLON.Vector3(0.04, 0.04, 0.04);

            player4 = task.loadedMeshes[0];
        }

        

        //      alien2.onSuccess = function (task1) {
        //          task1.loadedMeshes[0].position = new BABYLON.Vector3(0, 1, 1);
        //          task1.loadedMeshes[0].scaling = new BABYLON.Vector3(0.009, 0.009, 0.009);
        //          task1.loadedMeshes[0].rotate(BABYLON.Axis.X, -Math.PI / 2, BABYLON.Space.WORLD);
        //          alien2 = task1.loadedMeshes[0];
        //      }

        //      alien3.onSuccess = function (task1) {
        //          task1.loadedMeshes[0].position = new BABYLON.Vector3(-1, 1, 1);
        //          task1.loadedMeshes[0].scaling = new BABYLON.Vector3(0.009, 0.009, 0.009);
        //          task1.loadedMeshes[0].rotate(BABYLON.Axis.X, -Math.PI / 2, BABYLON.Space.WORLD);
        //          alien3 = task1.loadedMeshes[0];
        //      }

        //        alien4.onSuccess = function (task1) {
        //            task1.loadedMeshes[0].position = new BABYLON.Vector3(-1, 1, 1);
        //            task1.loadedMeshes[0].scaling = new BABYLON.Vector3(0.01, 0.01, 0.01);
        //            alien4 = task1.loadedMeshes[0];
        //        }

        player4.position = new BABYLON.Vector3(1, 1, 1);

        assetsManager.load(scene);


        var blueMat = new BABYLON.StandardMaterial("ground", scene);
        blueMat.diffuseColor = new BABYLON.Color3(1.0, 0.2, 0.7);
        blueMat.specularColor = new BABYLON.Color3(1.0, 0.2, 0.7);
        blueMat.emissiveColor = BABYLON.Color3.Blue();

        var userBullet = BABYLON.Mesh.CreateCylinder("bullet1", 0.5, 0.2, 0.2, 16, 1, scene, false, BABYLON.Mesh._DEFAULTSIDE);
        //var userBullet = BABYLON.Mesh.CreateCylinder('ship', 4.0, 3.0, 3.0, 16, null, scene);
        userBullet.rotation.x = Math.PI / 2;
        userBullet.isVisible = false;


        //Define an explosion - when something gets hit

        var explosion = BABYLON.Mesh.CreateBox('explosion', 0.01, scene);
        var particleSystem = new BABYLON.ParticleSystem("particles", 250, scene); //, customEffect);
        particleSystem.particleTexture = new BABYLON.Texture("Flare.png", scene);
        // Colors of all particles (splited in 2 + specific color before dispose)
        particleSystem.color1 = new BABYLON.Color4(0.7, 0.8, 1.0, 1.0);
        particleSystem.color2 = new BABYLON.Color4(0.2, 0.5, 1.0, 1.0);
        particleSystem.colorDead = new BABYLON.Color4(0, 0, 0.2, 0.0);
        // Size of each particle (random between...)
        particleSystem.minSize = 0.05;
        particleSystem.maxSize = 0.3;
        // Life time of each particle (random between...)
        particleSystem.minLifeTime = 0.3;
        particleSystem.maxLifeTime = 0.8;
        particleSystem.emitRate = 70;
        //Set the gravity of all particles (not necessarily down)
        particleSystem.gravity = new BABYLON.Vector3(0, -9.81, 0);
        //Direction
        particleSystem.direction1 = new BABYLON.Vector3(-7, 8, 3);
        particleSystem.direction2 = new BABYLON.Vector3(7, 8, -3);
        //Angular speed
        particleSystem.minAngularSpeed = 0;
        particleSystem.maxAngularSpeed = Math.PI;

        // move the sphere upward 1/2 of its height
        //sphere.position.y = 1;

        // create a built-in "ground" shape; its constructor takes the same 5 params as the sphere's one
        //   var ground = BABYLON.Mesh.CreateGround('ground1', 6, 6, 2, scene);

        var moveLeft = false,
	            moveRight = false,
                moveUp = false,
                moveDown = false;
        pressFire = false;


        scene.registerBeforeRender(function () {
            if (moveLeft) {
                player4.position.x -= .05;
            } else if (moveRight) {
                player4.position.x += .05;
            } else if (moveUp) {
                player4.position.y += .05;
            } else if (moveDown) {
                player4.position.y -= .05;
            } else if (pressFire) {

            }



            userBullets.forEach(function (userBulletClone) {
                if (userBulletClone.killed) {
                    // Nothing to do here
                } else {

                    userBulletClone.position.z += 0.05;

                    if (userBulletClone.position.z >= 13) {
                        userBulletClone.dispose();
                        userBullets.splice(0, 1);
                    }

                }
            });


        });

        // return the created scene

        return scene;
    }


    // call the createScene function
    var scene = createScene();

    // run the render loop
    engine.runRenderLoop(function () {
        scene.render();

    });

    // the canvas/window resize event handler
    window.addEventListener('resize', function () {
        maxWidth = canvas.scrollWidth;
        halfWidth = maxWidth / 2;
        engine.resize();
    });

};